// OK - merge bine
// ( O(n^2, O(1) )   - preprocessing, query  RMQ
#include <fstream.h>
#include <iomanip.h>

#define DIM 100

int a[DIM], n;    // sirul
int b[DIM][DIM]; // b[i][j] minimul din intervalul a[i...j]

void ReadArray();
void DinamicRMQ();
void WriteTable();
int Min(int a, int b);


int main()
{
	ReadArray();
	DinamicRMQ();
	WriteTable();

	return 0;
}

void ReadArray()
{
	ifstream fin("naive.in");
	fin >> n;
	for ( int i = 1; i <= n; i++ ) // O(n)
		fin >> a[i];
	fin.close();
}

void DinamicRMQ()       // O( (n*n)/2 )
{
	int i = 0, j = 0;
	for ( i = 1; i <= n; i++ )
	{
		b[i][i] = a[i];
		for ( j = i + 1; j <= n; j++ )
			b[i][j] = Min(b[i][j-1], a[j]);
	}
}

int Min(int a, int b)
{
	return a < b ? a : b;
}

void WriteTable()
{
	ofstream fout("naive.out");
	int i = 0, j = 0;
	for ( i = 1; i <= n; i++ )
	{
		for ( j = 1; j < i; j++ )
			fout << "   ";
		for ( j = i; j <= n; j++ )
			fout << setw(3) << b[i][j];
		fout << "\n";
	}
	fout.close();
}

